
 { some simple procedures for files }

 UNIT PUnFiles ;

 INTERFACE

 Procedure ToUseSomePath ( sn       : String ;
                           Var  sf  : String ;
                           Var  bf  : Boolean ) ;

 Procedure ToDefineIndexPrtFile ( StrPrtFile         : String ;
                                  Var  IndexPrtFile  : Byte   ) ;

 Procedure ToWriteSimpleText ;

 Procedure ToGetPrtFileName ( Var   OutFileName   : String ) ;

 IMPLEMENTATION

 Uses
   PUnCoTy ; { types and constants }

 Procedure ToUseSomePath ( sn       : String ;
                           Var  sf  : String ;
                           Var  bf  : Boolean ) ;
 Var
   fp  : TextFile ;
   ff  : File ;
   sp  : String ;
   sa  : String ;
   sb  : String ;
   np  : Byte ;
   ls  : Byte ;
   bs  : Boolean ;
   ir  : Integer ;
 Begin
   sf:=sn;
   bf:=FALSE;
   bs:=FALSE;
   AssignFile(fp,'pskyview.ini'); { text file for list of path }
 {$I-}
   ReSet(fp);
 {$I+}
   If  IOResult <> 0  Then  Exit ; { no *.ini file }
   ReadLn(fp,sp);
   CloseFile(fp);
   np:=Pos('=',sp);
   If  np > 0  Then  Delete(sp,1,np);
   ls:=Length(sp);
   If  ls < 2  Then  Exit; { string is too short }
   Repeat
     np:=Pos(';',sp);
     If  np > 0
       Then
         Begin
           sa:=Copy(sp,1,np-1);
           Delete(sp,1,np);
         End
       Else
         Begin
           sa:=sp;
           bs:=TRUE; { the end of the path string }
         End;
     np:=Pos(' ',sa);
     While  np > 0  Do
       Begin { without blanks }
         Delete(sa,np,1);
         np:=Pos(' ',sa);
       End;
     ls:=Length(sa);
     If  ls > 0
       Then
         Begin
           If  sa[ls] <> '\'  Then  sa:=sa+'\';
           sb:=sa+sn;
           AssignFile(ff,sb);
 {$I-}
           ReSet(ff);
 {$I+}
           ir:=IOResult;
           If  ir IN [ 0 , 5 ]
             Then { path and file are found }
               Begin
                 bf:=TRUE;
                 sf:=sb;
                 If  ir = 0  Then  CloseFile(ff);
               End;
         End;
   Until  ( bf OR bs ) ;
 End;

 { to attempt to open PrtFile and to write to the PrtFile
      if it is possible then IndexPrtFile = 0 else IndexPrtFile = 1 }

 Procedure ToDefineIndexPrtFile ( StrPrtFile         : String ;
                                  Var  IndexPrtFile  : Byte   ) ;
 Begin
   IndexPrtFile:=1;
   AssignFile(PrtFile,StrPrtFile);
 {$I-}
   ReWrite(PrtFile);
 {$I+}
   If  IOResult = 0
     Then  IndexPrtFile:=0
     Else  IndexPrtFile:=1;
   If  IndexPrtFile = 0  Then
     Begin
 {$I-}
       WriteLn(PrtFile);
 {$I+}
       If  IOResult = 0
         Then
           Begin
             Write(PrtFile,'           AstroLom program :  ');
             WriteLn(PrtFile,' some information about stars and planets');
             WriteLn(PrtFile);
           End
         Else  IndexPrtFile:=1;
     End;
 End;

 Procedure ToWriteSimpleText ;
 Begin
   WriteLn(PrtFile);
   WriteLn(PrtFile,' topocentric positions have been done',
                   ' with respect to three coordinate systems');
   WriteLn(PrtFile);
   WriteLn(PrtFile,' for horizontal system :',
                   ' az - azimith             ',
                   ' hh - altitude     in degree');
   WriteLn(PrtFile,' for equatorial system :',
                   ' aa - right ascension     ',
                   ' da - declination  in degree');
   WriteLn(PrtFile,' for ecliptical system :',
                   ' el - longitude           ',
                   ' eb - latitude     in degree');
   WriteLn(PrtFile,' for all three systems :',
                   ' r  - distance in kilometer');
   WriteLn(PrtFile);
 End;

 { a simple procedure to define the next name of the output file }

 Procedure ToGetPrtFileName ( Var   OutFileName   : String ) ;
 Var
   TFile   : TextFile ;
   n,nf    : Word ;
   st,sx,
   sn,sf   : String ;
   bf      : Boolean ;
 Begin
   st:='AstrP';
   sx:='.Out';
   bf:=TRUE;
   nf:=0;
   While  bf  Do
     Begin
       n:=0;
       nf:=nf+1;
       Str(nf:3,sn);
       If  sn[1] = ' '  Then  sn[1]:='0';
       If  sn[2] = ' '  Then  sn[2]:='0';
       sf:=st+sn+sx;
       AssignFile(TFile,sf);
 {$I-}
       ReSet(TFile);
 {$I+}
       If  IOResult = 0
         Then
           Begin
             n:=n+1;
             CloseFile(TFile);
           End;
       If  n = 0
         Then
           Begin
             bf:=FALSE;
             OutFileName:=sf;
           End
         Else
           If  nf = 999
             Then
               Begin
                 bf:=FALSE;
                 OutFileName:=st+'000'+sx;
               End;
     End;
 End;

 END.