unit UnFigMou;  // with Graphics and other Units

interface

uses
  Classes ,  // for TShiftState
  Controls ; //  TMouseButton

procedure ForMouseMove ( Shift  : TShiftState ;  x , y  : Integer ) ;

procedure ForMouseClick ( Button  : TMouseButton ;
                          Shift  : TShiftState ;  x , y  : Integer ) ;

implementation

uses
  UnMouSky ,  // for procedure CursorFigu MouseInSky
  UnMouBut ,  // for procedure MouseInBut MouseOutBut
  UnButIni ;  // for variables SkyCurX Y T  function PointInRec

procedure ForMouseMove ( Shift  : TShiftState ;  x , y  : Integer ) ;
begin
  CursorFigu(x,y); // cursor crCross inner Sky rectangle or crDefault
  MouseInSky(x,y); // mouse is in Sky rectangle unit UnMouSky
  if  not MouseInButt(x,y) // mouse may be or not in top panel with buttons
    then // from the unit UnMouBut
      MouseOutButt ; // unit UnMouBut
end;

procedure ForMouseClick ( Button  : TMouseButton ;
                          Shift  : TShiftState ;  x , y  : Integer ) ;
begin
  if  PointInRect(x,y,SkyRect) // from unit UnButIni
    then // mouse is out the sky rectangle
      begin
        if  Button = mbRight
          then // for PopupMenuS action
            MouseRightClick(x,y); // from unit UnMouSky
        if  Button = mbLeft // to change centre of the sky and a try
          then    // to choice and fix object after left mouse click
            MouseLeftClick(x,y); // from unit UnMouSky
      end;
  if  PointInRect(x,y,UpperR) or PointInRect(x,y,BottomR)
    then
      if  Button = mbLeft
        then
          MouseClickButton(x,y); // from unit UnMouSky
end;

end.

