unit UnMouBut; // for hint with hint property of Form

interface

uses
  Classes ,  // for TShiftState
  Controls , // for Cursor property
  Graphics , // for Color TextWidth
  Forms ;    // for bsNone of BorderStyle

function MouseInButt ( x , y  : Integer ) : Boolean ; // for buttons hint

procedure MouseOutButt ;

implementation

uses
  UnitMain ,  // for fmPuz class
  UnButIni ,  // for rectangular BottomR , SkyRect , UpperR , AllBut
  UnMouSky ;  // function PointInRect

procedure BoxInformFalse ( k  : Byte ) ;
begin
  AllButt[k].bo:=False;
  fmPuz.ShowHint:=False;
end;

function BeforeBoxInform : Byte ;
var // for number of the previous button with hint
  n  : Byte ;
begin
  BeforeBoxInform:=0;
  for n:=1 To NumButt do
    if  AllButt[n].bo
      then // there is previous button with hint
        BeforeBoxInform:=n;
end;

procedure HintForButton ( n  : Byte ) ;
var
  s  : ShortString ;
begin
  s:=AllButt[n].sh;
  if  Length(s) = 0  then  Exit ; // no hint
  AllButt[n].bo:=True;
  s:=' '+s+'  ';
  fmPuz.Hint:=s;
  fmPuz.ShowHint:=True;
end;

function WithAllButtons( k , n  : Byte ;
                         x , y  : Integer ) : Byte ;
var
  r  : TRectBut ;  // type from UnFigIni
begin
  WithAllButtons:=0;
  r:=AllButt[n].rb; // buttons rectangles from UnFigIni
  if  not PointInRect(x,y,r)  then  Exit ; // no mouse in this button UnMouSky
  WithAllButtons:=n; // mouse is in this button
  if  n = k  then  Exit ; // k - previous button , n - current button
  if  k > 0 // number of previous button not equal
    then    // number of current button
      BoxInformFalse(k); // function clear for box information
  HintForButton(n);
end;

function ToGetNextButton ( k  : Byte ;
                           x , y  : Integer ) : Byte ;
var
  n  : Byte ;
  m  : Byte ;
begin
  n:=0;
repeat
  n:=n+1;
  m:=WithAllButtons(k,n,x,y);
until  ( ( m > 0 ) or ( n = NumButt ) ) ;
  ToGetNextButton:=m; // current number
end;

{ mouse is in top panel or in bottom panel with buttons }

function MouseInButt ( x , y  : Integer ) : Boolean ; // for buttons hint
var
  m,k  : Byte ;
begin
  MouseInButt:=False;
  if  not ( PointInRect(x,y,UpperR) or PointInRect(x,y,BottomR) )
    then  // no mouse in two panel with buttons
      Exit ;
  k:=BeforeBoxInform;
  m:=ToGetNextButton(k,x,y);
  if  m = 0
    then
      BoxInformFalse(1)
    else
      MouseInButt:=True;
end;

procedure MouseOutButt ;
var
  k,n  : Byte ;
begin
  k:=0;
  for n:=1 To NumButt do
    if  AllButt[n].bo
      then
        k:=n;
  if  k > 0
    then
      BoxInformFalse(k);
end;

end.
