unit UnFilesO; // to find full path and to select from two stars catalogues
               // to find full path and to select from set of elements
interface

procedure ToSelectOneCatalogue ; // proc is called by ForButtonF from UnForBut

procedure ToSelectOneSetOfElem ; // proc is called by ForButtonE from UnForBut

implementation

uses
  UnitMain , // fmPuz
  Dialogs  , // for ShowMessage
  UnGloVar , // stPathCat and other global variables
  PUnCRead , // boolean ExistTRCFile
  UnSelFel , // fmSelFel
  UnSelFol ; // fmSelFol

procedure ToSelectOneCatalogue ; // proc is called by ForButtonF from UnForBut
begin
  fmSelFel.FileElemBox.Mask:='*bin.dat'; // fmSelFel UnSelFel
  fmSelFel.Caption:=' .  .';  // stPathCat UnGloVar
  fmSelFel.BinSelFel:=True; // to select binary file
  fmSelFel.BooSelFel:=False;
  if ExistTRCFile // global var from PUnCRead
    then  // var stPathCat from UnGloVar
      begin
        fmSelFel.stPathFel:=stPathCat; // folder with catalogues
        fmSelFel.ButtonFol.Enabled:=True;
        fmSelFel.ButtonFol.Visible:=True;
        fmSelFel.FileElemBox.ApplyFilePath(stPathCat); // stPathCat UnGloVar
        if  fmSelFel.FileElemBox.Items.Count > 0
          then
            fmSelFel.ShowModal; // form from UnSelFel for catalogues
        fmSelFel.ButtonFol.Enabled:=False;
        fmSelFel.ButtonFol.Visible:=False;
      end
    else
      fmSelFel.BofSelFel:=True;
  if  fmSelFel.BofSelFel // folders button is clicked
    then
      begin
        fmPuz.MenuEphCatClick(fmSelFel.SenderFel);
        if  not fmSelFol.BooSelectFolder  then  Exit ; // boolean fmSelFol
        fmSelFel.stPathFel:=stPathCat; // folder with catalogues
        fmSelFel.FileElemBox.ApplyFilePath(stPathCat); //  UnGloVar
        if  fmSelFel.FileElemBox.Items.Count < 1
          then // ShowMessage from unit Dialogs
            ShowMessage('  '+stPathCat+'   ')
          else
            fmSelFel.ShowModal;
      end;
end;

procedure ToSelectOneSetOfElem ; // proc is called by ForButtonE from UnForBut
begin // stPathElem is declared UnGloVar
  fmSelFel.FileElemBox.Mask:='*.tle;*.geo;*.kdr;*.irv;'
                            +'*.slr;*.txt;*.elm;*.sim';
  fmSelFel.Caption:=' .  .';
  fmSelFel.stPathFel:=stPathElem; // folder with elements files
  fmSelFel.BinSelFel:=False; // to select textfile but not binary file
  fmSelFel.BooSelFel:=False;
  fmSelFel.ButtonFol.Enabled:=True;
  fmSelFel.ButtonFol.Visible:=True;
  fmSelFel.FileElemBox.ApplyFilePath(fmSelFel.stPathFel);
  if  fmSelFel.FileElemBox.Items.Count > 0
    then // files exist
      fmSelFel.ShowModal  // form UnSelFel to select file
    else // to select other folder
      fmSelFel.BofSelFel:=True;
  fmSelFel.ButtonFol.Enabled:=False;
  fmSelFel.ButtonFol.Visible:=False;
  if  fmSelFel.BofSelFel // folders button is clicked
    then
      begin
        fmPuz.MenuEphElmClick(fmSelFel.SenderFel);
        if  not fmSelFol.BooSelectFolder  then  Exit ; // boolean fmSelFol
        fmSelFel.BooSelFel:=False;
        fmSelFel.stPathFel:=stPathElem; // folder with elements files
        fmSelFel.FileElemBox.ApplyFilePath(fmSelFel.stPathFel);
        if  fmSelFel.FileElemBox.Items.Count > 0
          then // files exist
            fmSelFel.ShowModal  // form UnSelFel to select file
          else // to select other folder
            ShowMessage('  '+stPathElem+'   ');
      end;
end;

end.
