unit UnGraBmp ; // a try to save BitMap
interface
uses
  Windows  , // TRect type
  Graphics ; // TCanvas
procedure PuzSaveBmp ( wc , hc  : Integer ;
                       wf , hf  : Integer ;
                       kw , kf  : Integer ;
                       fCanvas  : TCanvas ) ;
implementation
uses
  UnitMain ; // for fmPuz.SavePictureDialog method
procedure PuzSaveBmp ( wc , hc  : Integer ;
                       wf , hf  : Integer ;
                       kw , kf  : Integer ;
                       fCanvas  : TCanvas ) ;
var
  BitMap  : TBitMap ;  // from Graphics
  dst,sr  : TRect ;    // form Windows
begin
  BitMap:=TBitMap.Create;
  BitMap.Width:=wf;
  BitMap.Height:=hf;
  sr.Left:=wc-wf+kw;
  sr.Top:=hc-hf+kf;
  sr.Right:=sr.Left+wf;
  sr.Bottom:=sr.Top+hf;
  dst.Left:=0;
  dst.Top:=0;
  dst.Right:=BitMap.Width;
  dst.Bottom:=BitMap.Height;
  BitMap.Canvas.CopyRect(dst,fCanvas,sr);
  if  fmPuz.SavePictureDialog.Execute
    then
      BitMap.SaveToFile(fmPuz.SavePictureDialog.FileName);
  BitMap.Free;
end;

end.