
 UNIT UnitSatF ; // some procedures for satellites files

 INTERFACE

 Procedure ToFindFileWithPattern ( PattForName  : ShortString ;
                                   Var  bofile  : Boolean ;
                                   Var  stfile  : ShortString ) ;

 Procedure SatNoradFileFind ; // to find file with *.tle by unit UnGetIni

 IMPLEMENTATION

 Uses
   UnConTyp ,
   UnCoTVar , // type TElemRec
   UnGloVar , // for BooSatElem BooExistSat
   SysUtils , // for type TSearhRec
   UnrfNord ; // for stNoradFile for procedure ToReadNoradFormat

 Procedure ToFindFileWithPattern ( PattForName  : ShortString ;
                                   Var  bofile  : Boolean ;
                                   Var  stfile  : ShortString ) ;
 Var
   DirFile   : TSearchRec ;
   DosError  : Integer ;
 Begin
   bofile:=False;
   stfile:='';
   DosError:=FindFirst(PattForName,faArchive,DirFile);
   if  DosError = 0
     then // there is one file
       begin
         stfile:=DirFile.Name;
         bofile:=True;
       end;
   FindClose(DirFile);
 End;

 Function NorElements : Boolean ;
 Begin
   ToReadNoradFormat(stElementFile); // from UnrfNord
   If  NumSatElemInHeap > 0 // var LongInt from UnCoTVar
     Then  NorElements:=TRUE  // global string stElementFile from UnGloVar
     Else  NorElements:=FALSE;
 End;

 Procedure SatNoradFileFind ; // to find files with *.tle extention
 var
   boof  : Boolean ;
 Begin
   BooSatElem:=FALSE;  // variables in UnGloVar
   BooExistSat:=FALSE;
   NumSatElemInHeap:=0; // initial values variable from UnCoTVar
   ToFindFileWithPattern('*.tle',boof,stElementFile); // UnitSatF
   If  boof  // there is file with satellites elements
     Then  BooSatElem:=NorElements // for ToReadNoradFormat(stNoradFile) ;
     Else  BooSatElem:=FALSE; // no file with satellites elements
   If  ( BooSatElem AND ( JulianDate > 2436147.0 ) ) // var in UnGloVar
     Then
       BooExistSat:=TRUE
     Else
       BooExistSat:=FALSE;
 End;

 END.
