unit UnPlateC; // for simple procedures for ideal coordinates in plate

interface

 Procedure IdealCoordinates ( azt , alt  : Extended ;
                              Var  ksi , eta  : Extended ) ;

 Procedure SpherCoordinates ( x , y  : Integer ;  Var  a , b  : Extended ) ;

implementation

uses
  UnConTyp , // const RadGra
  UnGloVar , // var AzimutC AltitudeC
  PUnCRead , // procedure FromSphericToIdeal...
  UnButIni ; // records SkyParm

 Procedure IdealCoordinates ( azt , alt  : Extended ;
                              Var  ksi , eta  : Extended ) ;
 Begin
   FromSphericToIdealCoordinates(azt,alt, // in degree in radian
                                 AzimutC,AltitudeC,ksi,eta); // unit PUnCRead
   ksi:=RadGra*ksi; // RadGra from unit UnConTyp
   eta:=RadGra*eta; // from radian to degree
 End;

 Procedure SpherCoordinates ( x , y  : Integer ;  Var  a , b  : Extended ) ;
 Var
   ksi,eta  : Extended ; // record SkyParm from unit UnButIni
 Begin // to obtain spherical position from current x y on the screen
   ksi:=GraRad*SkyParm.rx*XinDegC*(SkyParm.xh-x)/SkyParm.dx; // in radian
   eta:=GraRad*SkyParm.ry*YinDegC*(SkyParm.yh-y)/SkyParm.dy; // in radian
   FromIdealToSphericCoordinates(ksi,eta, // in radian  in degree
                                 AzimutC,AltitudeC,a,b); // PUnCRead
 End;

end.
