
 UNIT UW_Cnst ;

 INTERFACE

 Type
   ConstellatioName  = Record
                         LatN           : String[3]  ;
                         RusN           : ShortString ;
                       End;
   ConstelLatiName   = Record
                         LatN           : String[3]  ;
                         Latin          : ShortString ;
                       End;

 Const
   DimConStel       : Array[1..88] of ConstellatioName  =
          ( ( LatN  : 'And' ;  RusN : '' ) ,
            ( LatN  : 'Peg' ;  RusN : '' ) ,
            ( LatN  : 'Per' ;  RusN : '' ) ,
            ( LatN  : 'Aqr' ;  RusN : '' ) ,
            ( LatN  : 'Aql' ;  RusN : '' ) ,
            ( LatN  : 'Ari' ;  RusN : '' ) ,
            ( LatN  : 'UMa' ;  RusN : ' ' ) ,
            ( LatN  : 'UMi' ;  RusN : ' ' ) ,
            ( LatN  : 'Vir' ;  RusN : '' ) ,
            ( LatN  : 'Aur' ;  RusN : '' ) ,
            ( LatN  : 'Boo' ;  RusN : '' ) ,
            ( LatN  : 'Leo' ;  RusN : '' ) ,
            ( LatN  : 'Gem' ;  RusN : '' ) ,
            ( LatN  : 'CMa' ;  RusN : ' ' ) ,
            ( LatN  : 'CMi' ;  RusN : ' ' ) ,
            ( LatN  : 'Tau' ;  RusN : '' ) ,
            ( LatN  : 'Ori' ;  RusN : '' ) ,
            ( LatN  : 'Cap' ;  RusN : '' ) ,
            ( LatN  : 'Car' ;  RusN : '' ) ,
            ( LatN  : 'Cas' ;  RusN : '' ) ,
            ( LatN  : 'Cyg' ;  RusN : '' ) ,
            ( LatN  : 'Lyr' ;  RusN : '' ) ,
            ( LatN  : 'Cru' ;  RusN : ' ' ) ,
            ( LatN  : 'Eri' ;  RusN : '' ) ,
            ( LatN  : 'Sgr' ;  RusN : '' ) ,
            ( LatN  : 'Sco' ;  RusN : '' ) ,
            ( LatN  : 'Cnc' ;  RusN : '' ) ,
            ( LatN  : 'Lib' ;  RusN : '' ) ,
            ( LatN  : 'Her' ;  RusN : '' ) ,
            ( LatN  : 'Cen' ;  RusN : '' ) ,
            ( LatN  : 'Cep' ;  RusN : '' ) ,
            ( LatN  : 'Gru' ;  RusN : '' ) ,
            ( LatN  : 'Hor' ;  RusN : '' ) ,
            ( LatN  : 'Hya' ;  RusN : '' ) ,
            ( LatN  : 'Hyi' ;  RusN : ' ' ) ,
            ( LatN  : 'Ind' ;  RusN : '' ) ,
            ( LatN  : 'CVn' ;  RusN : ' ' ) ,
            ( LatN  : 'Lac' ;  RusN : '' ) ,
            ( LatN  : 'LMi' ;  RusN : ' ' ) ,
            ( LatN  : 'Lep' ;  RusN : '' ) ,
            ( LatN  : 'Lup' ;  RusN : '' ) ,
            ( LatN  : 'Lyn' ;  RusN : '' ) ,
            ( LatN  : 'Men' ;  RusN : ' ' ) ,
            ( LatN  : 'Mic' ;  RusN : '' ) ,
            ( LatN  : 'Mon' ;  RusN : '' ) ,
            ( LatN  : 'Mus' ;  RusN : '' ) ,
            ( LatN  : 'Nor' ;  RusN : '' ) ,
            ( LatN  : 'Oct' ;  RusN : '' ) ,
            ( LatN  : 'Oph' ;  RusN : '' ) ,
            ( LatN  : 'Pav' ;  RusN : '' ) ,
            ( LatN  : 'For' ;  RusN : '' ) ,
            ( LatN  : 'Phe' ;  RusN : '' ) ,
            ( LatN  : 'Pic' ;  RusN : '' ) ,
            ( LatN  : 'Psc' ;  RusN : '' ) ,
            ( LatN  : 'PsA' ;  RusN : ' ' ) ,
            ( LatN  : 'Pup' ;  RusN : '' ) ,
            ( LatN  : 'Pyx' ;  RusN : '' ) ,
            ( LatN  : 'Ret' ;  RusN : '' ) ,
            ( LatN  : 'Sge' ;  RusN : '' ) ,
            ( LatN  : 'Scl' ;  RusN : '' ) ,
            ( LatN  : 'Sct' ;  RusN : '' ) ,
            ( LatN  : 'Ser' ;  RusN : '' ) ,
            ( LatN  : 'Sex' ;  RusN : '' ) ,
            ( LatN  : 'Del' ;  RusN : '' ) ,
            ( LatN  : 'Dor' ;  RusN : ' ' ) ,
            ( LatN  : 'Dra' ;  RusN : '' ) ,
            ( LatN  : 'Equ' ;  RusN : ' ' ) ,
            ( LatN  : 'Tel' ;  RusN : '' ) ,
            ( LatN  : 'Tri' ;  RusN : '' ) ,
            ( LatN  : 'TrA' ;  RusN : ' ' ) ,
            ( LatN  : 'Tuc' ;  RusN : '' ) ,
            ( LatN  : 'Cet' ;  RusN : '' ) ,
            ( LatN  : 'Cha' ;  RusN : '' ) ,
            ( LatN  : 'Cir' ;  RusN : '' ) ,
            ( LatN  : 'Col' ;  RusN : '' ) ,
            ( LatN  : 'Com' ;  RusN : ' ' ) ,
            ( LatN  : 'CrA' ;  RusN : ' ' ) ,
            ( LatN  : 'CrB' ;  RusN : ' ' ) ,
            ( LatN  : 'Crv' ;  RusN : '' ) ,
            ( LatN  : 'Crt' ;  RusN : '' ) ,
            ( LatN  : 'Vel' ;  RusN : '' ) ,
            ( LatN  : 'Cae' ;  RusN : '' ) ,
            ( LatN  : 'Cam' ;  RusN : '' ) ,
            ( LatN  : 'Ant' ;  RusN : '' ) ,
            ( LatN  : 'Ara' ;  RusN : '' ) ,
            ( LatN  : 'Aps' ;  RusN : ' ' ) ,
            ( LatN  : 'Vol' ;  RusN : ' ' ) ,
            ( LatN  : 'Vul' ;  RusN : '' ) ) ;
   DimConSteLatin  : Array[1..88] of ConstelLatiName  =
          ( ( LatN  : 'And' ;  Latin : 'Andromeda' ) ,
            ( LatN  : 'Peg' ;  Latin : 'Pegasus' ) ,
            ( LatN  : 'Per' ;  Latin : 'Perseus' ) ,
            ( LatN  : 'Aqr' ;  Latin : 'Aquarius' ) ,
            ( LatN  : 'Aql' ;  Latin : 'Aquila' ) ,
            ( LatN  : 'Ari' ;  Latin : 'Aries' ) ,
            ( LatN  : 'UMa' ;  Latin : 'Ursa Major' ) ,
            ( LatN  : 'UMi' ;  Latin : 'Ursa Minor' ) ,
            ( LatN  : 'Vir' ;  Latin : 'Virgo' ) ,
            ( LatN  : 'Aur' ;  Latin : 'Auriga' ) ,
            ( LatN  : 'Boo' ;  Latin : 'Bootes' ) ,
            ( LatN  : 'Leo' ;  Latin : 'Leo' ) ,
            ( LatN  : 'Gem' ;  Latin : 'Gemini' ) ,
            ( LatN  : 'CMa' ;  Latin : 'Canis Major' ) ,
            ( LatN  : 'CMi' ;  Latin : 'Canis Minor' ) ,
            ( LatN  : 'Tau' ;  Latin : 'Taurus' ) ,
            ( LatN  : 'Ori' ;  Latin : 'Orion' ) ,
            ( LatN  : 'Cap' ;  Latin : 'Capricornus' ) ,
            ( LatN  : 'Car' ;  Latin : 'Carina' ) ,
            ( LatN  : 'Cas' ;  Latin : 'Cassiopeia' ) ,
            ( LatN  : 'Cyg' ;  Latin : 'Cygnus' ) ,
            ( LatN  : 'Lyr' ;  Latin : 'Lyra' ) ,
            ( LatN  : 'Cru' ;  Latin : 'Crux' ) ,
            ( LatN  : 'Eri' ;  Latin : 'Eridanus' ) ,
            ( LatN  : 'Sgr' ;  Latin : 'Sagittarius' ) ,
            ( LatN  : 'Sco' ;  Latin : 'Scorpius' ) ,
            ( LatN  : 'Cnc' ;  Latin : 'Cancer' ) ,
            ( LatN  : 'Lib' ;  Latin : 'Libra' ) ,
            ( LatN  : 'Her' ;  Latin : 'Hercules' ) ,
            ( LatN  : 'Cen' ;  Latin : 'Centaurus' ) ,
            ( LatN  : 'Cep' ;  Latin : 'Cepheus' ) ,
            ( LatN  : 'Gru' ;  Latin : 'Grus' ) ,
            ( LatN  : 'Hor' ;  Latin : 'Horologium' ) ,
            ( LatN  : 'Hya' ;  Latin : 'Hydra' ) ,
            ( LatN  : 'Hyi' ;  Latin : 'Hydrus' ) ,
            ( LatN  : 'Ind' ;  Latin : 'Indus' ) ,
            ( LatN  : 'CVn' ;  Latin : 'Canes Venatici' ) ,
            ( LatN  : 'Lac' ;  Latin : 'Lacerta' ) ,
            ( LatN  : 'LMi' ;  Latin : 'Leo Minor' ) ,
            ( LatN  : 'Lep' ;  Latin : 'Lepus' ) ,
            ( LatN  : 'Lup' ;  Latin : 'Lupus' ) ,
            ( LatN  : 'Lyn' ;  Latin : 'Lynx' ) ,
            ( LatN  : 'Men' ;  Latin : 'Mensa' ) ,
            ( LatN  : 'Mic' ;  Latin : 'Microscopium' ) ,
            ( LatN  : 'Mon' ;  Latin : 'Monoceros' ) ,
            ( LatN  : 'Mus' ;  Latin : 'Musca' ) ,
            ( LatN  : 'Nor' ;  Latin : 'Norma' ) ,
            ( LatN  : 'Oct' ;  Latin : 'Octans' ) ,
            ( LatN  : 'Oph' ;  Latin : 'Ophiuchus' ) ,
            ( LatN  : 'Pav' ;  Latin : 'Pavo' ) ,
            ( LatN  : 'For' ;  Latin : 'Fornax' ) ,
            ( LatN  : 'Phe' ;  Latin : 'Phoenix' ) ,
            ( LatN  : 'Pic' ;  Latin : 'Pictor' ) ,
            ( LatN  : 'Psc' ;  Latin : 'Pisces' ) ,
            ( LatN  : 'PsA' ;  Latin : 'Piscis Austrinus' ) ,
            ( LatN  : 'Pup' ;  Latin : 'Puppis' ) ,
            ( LatN  : 'Pyx' ;  Latin : 'Pyxis' ) ,
            ( LatN  : 'Ret' ;  Latin : 'Reticulum' ) ,
            ( LatN  : 'Sge' ;  Latin : 'Sagitta' ) ,
            ( LatN  : 'Scl' ;  Latin : 'Sculptor' ) ,
            ( LatN  : 'Sct' ;  Latin : 'Scutum' ) ,
            ( LatN  : 'Ser' ;  Latin : 'Serpens' ) ,
            ( LatN  : 'Sex' ;  Latin : 'Sextans' ) ,
            ( LatN  : 'Del' ;  Latin : 'Delphinus' ) ,
            ( LatN  : 'Dor' ;  Latin : 'Dorado' ) ,
            ( LatN  : 'Dra' ;  Latin : 'Draco' ) ,
            ( LatN  : 'Equ' ;  Latin : 'Equuleus' ) ,
            ( LatN  : 'Tel' ;  Latin : 'Telescopium' ) ,
            ( LatN  : 'Tri' ;  Latin : 'Triangulum' ) ,
            ( LatN  : 'TrA' ;  Latin : 'Triangul Australe' ) ,
            ( LatN  : 'Tuc' ;  Latin : 'Tucan' ) ,
            ( LatN  : 'Cet' ;  Latin : 'Cetus' ) ,
            ( LatN  : 'Cha' ;  Latin : 'Chamaeleon' ) ,
            ( LatN  : 'Cir' ;  Latin : 'Circinus' ) ,
            ( LatN  : 'Col' ;  Latin : 'Columba' ) ,
            ( LatN  : 'Com' ;  Latin : 'Coma Berenices' ) ,
            ( LatN  : 'CrA' ;  Latin : 'Corona Australis' ) ,
            ( LatN  : 'CrB' ;  Latin : 'Corona Borealis' ) ,
            ( LatN  : 'Crv' ;  Latin : 'Corvus' ) ,
            ( LatN  : 'Crt' ;  Latin : 'Crater' ) ,
            ( LatN  : 'Vel' ;  Latin : 'Velorum' ) ,
            ( LatN  : 'Cae' ;  Latin : 'Caelum' ) ,
            ( LatN  : 'Cam' ;  Latin : 'Camelopardalis' ) ,
            ( LatN  : 'Ant' ;  Latin : 'Antlia' ) ,
            ( LatN  : 'Ara' ;  Latin : 'Ara' ) ,
            ( LatN  : 'Aps' ;  Latin : 'Apus' ) ,
            ( LatN  : 'Vol' ;  Latin : 'Volans' ) ,
            ( LatN  : 'Vul' ;  Latin : 'Vulpecula' ) ) ;

 Type
   StarName  = Record
                 FK5Number              : Word ;
                 ProperName             : String[11] ;
               End;

 Const
   MaxProperName    = 42 ;
   DimStarName      : Array[1..MaxProperName] of StarName   =
      ( ( FK5Number :   54 ; ProperName : '  Achernar ' ) ,
        ( FK5Number :  168 ; ProperName : ' Aldebaran ' ) ,
        ( FK5Number :  111 ; ProperName : '     Algol ' ) ,
        ( FK5Number :  745 ; ProperName : '    Altair ' ) ,
        ( FK5Number :  616 ; ProperName : '   Antares ' ) ,
        ( FK5Number :  526 ; ProperName : '  Arcturus ' ) ,
        ( FK5Number :  224 ; ProperName : 'Betelgeuse ' ) ,  { alfa Ori }
        ( FK5Number :  201 ; ProperName : 'Bellactrix ' ) ,  { gamma Ori }
        ( FK5Number :  245 ; ProperName : '   Canopus ' ) ,
        ( FK5Number :  193 ; ProperName : '   Capella ' ) ,
        ( FK5Number :  287 ; ProperName : '    Castor ' ) ,
        ( FK5Number :  777 ; ProperName : '     Deneb ' ) ,
        ( FK5Number :  444 ; ProperName : '  Denebola ' ) ,
        ( FK5Number :  417 ; ProperName : '     Dubhe ' ) ,
        ( FK5Number :  867 ; ProperName : ' Fomalhaut ' ) ,
        ( FK5Number :  907 ; ProperName : '   Polaris ' ) ,
        ( FK5Number :  295 ; ProperName : '     Polux ' ) ,
        ( FK5Number :  291 ; ProperName : '   Procyon ' ) ,
        ( FK5Number :  380 ; ProperName : '   Regulus ' ) ,
        ( FK5Number :  194 ; ProperName : '     Rigel ' ) ,  { beta Ori }
        ( FK5Number :  257 ; ProperName : '    Sirius ' ) ,
        ( FK5Number :  498 ; ProperName : '     Spica ' ) ,
        ( FK5Number :  699 ; ProperName : '      Vega ' ) ,
        ( FK5Number :    1 ; ProperName : '   Alferac ' ) ,
        ( FK5Number :   42 ; ProperName : '     Mirah ' ) ,
        ( FK5Number :   73 ; ProperName : '    Alamac ' ) ,
        ( FK5Number :  202 ; ProperName : '      Nath ' ) , { beta Tau }
        ( FK5Number :  139 ; ProperName : '   Alciona ' ) , { eta Tau }
        ( FK5Number :  416 ; ProperName : '     Merak ' ) , { beta UMa }
        ( FK5Number :  447 ; ProperName : '    Phekda ' ) , { gamma UMa }
        ( FK5Number :  456 ; ProperName : '    Megrec ' ) , { delta UMa }
        ( FK5Number :  483 ; ProperName : '     Aliot ' ) , { epsilon UMa }
        ( FK5Number :  497 ; ProperName : '     Micar ' ) , { dzeta UMa }
        ( FK5Number :  509 ; ProperName : '    Alkaid ' ) , { eta UMa }
        ( FK5Number :  206 ; ProperName : '   Mintaka ' ) , { delta Ori }
        ( FK5Number :  210 ; ProperName : '   Alnilam ' ) , { epsilon Ori }
        ( FK5Number :  200 ; ProperName : '   Alnitak ' ) , { dzeta Ori }
        ( FK5Number :  120 ; ProperName : '   Mirphak ' ) , { alfa Per }
        ( FK5Number :  538 ; ProperName : '   Toliman ' ) , { alfa Cen } 
        ( FK5Number :  462 ; ProperName : '     Akrux ' ) , { alfa Cru } 
        ( FK5Number :  251 ; ProperName : '   Alphena ' ) , { gamma Gem }
        ( FK5Number :  279 ; ProperName : '     Vasat ' ) ) ; { delta Gem }
   RusStarName      : Array[1..MaxProperName] of StarName   =
      ( ( FK5Number :   54 ; ProperName : '    ' ) ,
        ( FK5Number :  168 ; ProperName : ' ' ) ,
        ( FK5Number :  111 ; ProperName : '     ' ) ,
        ( FK5Number :  745 ; ProperName : '    ' ) ,
        ( FK5Number :  616 ; ProperName : '    ' ) ,
        ( FK5Number :  526 ; ProperName : '     ' ) ,
        ( FK5Number :  224 ; ProperName : '' ) ,  { alfa Ori }
        ( FK5Number :  201 ; ProperName : '' ) ,  { gamma Ori }
        ( FK5Number :  245 ; ProperName : '    ' ) ,
        ( FK5Number :  193 ; ProperName : '    ' ) ,
        ( FK5Number :  287 ; ProperName : '     ' ) ,
        ( FK5Number :  777 ; ProperName : '      ' ) ,
        ( FK5Number :  444 ; ProperName : '   ' ) ,
        ( FK5Number :  417 ; ProperName : '      ' ) ,
        ( FK5Number :  867 ; ProperName : ' ' ) ,
        ( FK5Number :  907 ; ProperName : '   ' ) ,
        ( FK5Number :  295 ; ProperName : '     ' ) ,
        ( FK5Number :  291 ; ProperName : '    ' ) ,
        ( FK5Number :  380 ; ProperName : '      ' ) ,
        ( FK5Number :  194 ; ProperName : '     ' ) ,  { beta Ori }
        ( FK5Number :  257 ; ProperName : '     ' ) ,
        ( FK5Number :  498 ; ProperName : '      ' ) ,
        ( FK5Number :  699 ; ProperName : '       ' ) ,
        ( FK5Number :    1 ; ProperName : '   ' ) ,
        ( FK5Number :   42 ; ProperName : '      ' ) ,
        ( FK5Number :   73 ; ProperName : '     ' ) ,
        ( FK5Number :  202 ; ProperName : '       ' ) , { beta Tau }
        ( FK5Number :  139 ; ProperName : '   ' ) , { eta Tau }
        ( FK5Number :  416 ; ProperName : '      ' ) , { beta UMa }
        ( FK5Number :  447 ; ProperName : '      ' ) , { gamma UMa }
        ( FK5Number :  456 ; ProperName : '     ' ) , { delta UMa }
        ( FK5Number :  483 ; ProperName : '      ' ) , { epsilon UMa }
        ( FK5Number :  497 ; ProperName : '      ' ) , { dzeta UMa }
        ( FK5Number :  509 ; ProperName : '    ' ) , { eta UMa }
        ( FK5Number :  206 ; ProperName : '    ' ) , { delta Ori }
        ( FK5Number :  210 ; ProperName : '    ' ) , { epsilon Ori }
        ( FK5Number :  200 ; ProperName : '    ' ) , { dzeta Ori }
        ( FK5Number :  120 ; ProperName : '     ' ) , { alfa Per }
        ( FK5Number :  538 ; ProperName : '    ' ) , { alfa Cen } 
        ( FK5Number :  462 ; ProperName : '     ' ) , { alfa Cru } 
        ( FK5Number :  251 ; ProperName : '    ' ) , { gamma Gem }
        ( FK5Number :  279 ; ProperName : '      ' ) ) ; { delta Gem }

 IMPLEMENTATION

 END.